/**
 * Copyright © 2021 SVDevelopments. All rights reserved.
 *
 * @package  SVDevelopments_SliderOptions
 * @author   SVDevelopments
 */

 define([
    'jquery',
    'mage/utils/wrapper',
    'Magento_PageBuilder/js/events',
    'slick'
], function ($, wrapper, events, slick) {
    'use strict';

    return function (carouselWidget) {
        return wrapper.wrap(carouselWidget, function (originalCarouselWidgetFunction, config, sliderElement) {
            originalCarouselWidgetFunction(config, sliderElement);

            var element = '.'+sliderElement[0].className+' .widget-product-carousel';

            $(element).on('init', function(event, slick){
                //console.log("initialized")
                if($(window).width() >= 1024) {
                    $(element).slick(
                        'slickSetOption',
                        'slidesToShow',
                        parseInt(sliderElement[0].attributes[9].value) ?? 5
                    );

                    $(element).slick(
                        'slickSetOption',
                        'slidesToScroll',
                        parseInt(sliderElement[0].attributes[10].value) ?? 5
                    );
                }

                //Equalize Heights of Divs
                setTimeout(function () {
                    if($(element).hasClass('slick-initialized')) {
                        $(element+' .slick-slide .product-item .product-item-details').addClass('equalheightdiv');
                        var infContainer = 0;
                        $(element+' .equalheightdiv').each(function() {
                            var thisHeight = $(this).height();
                            if(thisHeight > infContainer) {
                                infContainer = thisHeight + 1;
                            }
                        });
                        $(element+' .equalheightdiv').height(infContainer);
                    }
                }, 500);
            });

            $(element).slick()

        });
    };
});
