<?php

namespace Ymina\Checkout\Block\Customer\Widget;

use Magento\Framework\View\Element\Template;
use Magento\Customer\Model\AddressFactory;

class Rut extends Template
{

    protected $_addressFactory;

    public function __construct(
        Template\Context $context,
        AddressFactory   $addressFactory,
        array            $data = []
    )
    {
        $this->_addressFactory = $addressFactory;
        $this->setTemplate('Ymina_Checkout::address/widget/rut.phtml');
        parent::__construct($context, $data);
    }


    /**
     * @return string|null
     */
    public function getValue()
    {
        $addressId = $this->getRequest()->getParam('id');
        if ($addressId) {
            $addressCollection = $this->_addressFactory->create()->load($addressId);
            $rut = $addressCollection->getRut();

            if ($rut) {
                return $rut;
            }
            if ($this->getRequest()->getParam('rut')) {
                return $this->getRequest()->getParam('rut');
            }
        }
        return null;
    }
}