<?php

namespace Ymina\Checkout\Block;

class LayoutProcessor implements \Magento\Checkout\Block\Checkout\LayoutProcessorInterface
{

    private const ATTRIBUTE_CODE = 'rut';

    /**
     * @var \Psr\Log\LoggerInterface
     */
    private $_logger;

    public function __construct(\Psr\Log\LoggerInterface $logger)
    {
        $this->_logger = $logger;
    }


    /**
     * @param $jsLayout
     * @return array
     */
    public function process($jsLayout)
    {
        ///$this->_logger->info(json_encode($jsLayout));
        //
        //

        //17.739.327-4
        if (isset($jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']
            ['children']['shippingAddress']['children']
            ['shipping-address-fieldset']['children']['fax'])) {
            $fax = $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']
            ['children']['shippingAddress']['children']
            ['shipping-address-fieldset']['children']['fax'];
            $fax['component'] = 'Ymina_Checkout/js/form/element/checkbox-set';
            $fax['label'] = '';
            $fax['provider'] = 'checkoutProvider';
            $fax['dataScope'] = 'shippingAddress.fax';
            $fax['config'] = [
                'customScope' => 'shippingAddress',
                'template' => 'Ymina_Checkout/form/element/checkbox-set',
                'elementTmpl' => 'ui/form/element/checkbox-set',
                'customEntry' => 'shippingAddress.fax',
                'additionalClasses' => 'shipping-type-document',
            ];
            $fax['multiple'] = false;
            $fax['options'] = [
                0 => [
                    'value' => 'RUT',
                    'label' => __('RUT:')
                ],
                1 => [
                    'value' => 'Pasaporte/DNI',
                    'label' => __('Pasaporte/DNI:')
                ]
            ];

            $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']
            ['children']['shippingAddress']['children']
            ['shipping-address-fieldset']['children']['fax'] = $fax;
        }


        if (isset($jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']['shippingAddress']['children']['shipping-address-fieldset']['children'][self::ATTRIBUTE_CODE])) {
            /*$jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']
            ['shippingAddress']['children']['shipping-address-fieldset']['children'][self::ATTRIBUTE_CODE]['dataScope'] = 'shippingAddress.custom_attributes.' . self::ATTRIBUTE_CODE;
            $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']
            ['shippingAddress']['children']['shipping-address-fieldset']['children'][self::ATTRIBUTE_CODE]['placeholder'] = __("Rut");*/
            unset($jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']['shippingAddress']['children']['shipping-address-fieldset']['children'][self::ATTRIBUTE_CODE]);
        }
        return $jsLayout;
    }
}