<?php

namespace Ymina\Checkout\Controller\Index;


use Magento\Framework\App\ResourceConnection;

class Index extends \Magento\Framework\App\Action\Action
{

    protected $resultPageFactory;
    protected $jsonHelper;
    private \Magento\Framework\App\Action\Context $context;
    private ResourceConnection $resourceConnection;

    /**
     * Constructor
     *
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Magento\Framework\Json\Helper\Data $jsonHelper
     */
    public function __construct(
        \Magento\Framework\App\Action\Context      $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Framework\Json\Helper\Data        $jsonHelper,
        ResourceConnection                         $resourceConnection
    )
    {
        $this->resultPageFactory = $resultPageFactory;
        $this->jsonHelper = $jsonHelper;
        $this->resourceConnection = $resourceConnection;
        parent::__construct($context);
    }

    /**
     * Execute view action
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function execute()
    {
        try {

            if (!$this->_request->getParam('regionId')) {
                return $this->jsonResponse('required regionId key');
            }
            $options = [];
            $regionId = $this->_request->getParam('regionId');
            $connection = $this->resourceConnection->getConnection();
            $tableName = $connection->getTableName('cities');
            $sql = 'SELECT id, city FROM ' . $tableName . ' WHERE state_id = ' . $regionId . ' ORDER BY city ASC';
            $data = $connection->fetchAll($sql);
            if ($data && is_array($data)) {
                foreach ($data as $comuna) {
                    $options[] = [
                        'title' => $comuna["city"],
                        'value' => $comuna["city"],
                        'label' => $comuna["city"],
                    ];
                }
            }else{
                $options[] = [
                    'title' => "Seleccione comuna",
                    'value' => "",
                    'label' => "Seleccione comuna"
                ];
            }

            return $this->jsonResponse(['options' => $options, 'region_id' => $this->_request->getParam('regionId')]);
        } catch (\Magento\Framework\Exception\LocalizedException $e) {
            return $this->jsonResponse($e->getMessage());
        } catch (\Exception $e) {
            return $this->jsonResponse($e->getMessage());
        }
    }

    /**
     * Create json response
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function jsonResponse($response = '')
    {
        return $this->getResponse()->representJson(
            $this->jsonHelper->jsonEncode($response)
        );
    }
}
