<?php

namespace Ymina\Checkout\Observer;


use Magento\Framework\Event\Observer;
use Magento\Quote\Model\QuoteRepository;
use Magento\Sales\Model\Order;
use Magento\Sales\Model\OrderRepository;
use \Psr\Log\LoggerInterface;


class PlaceOrder implements \Magento\Framework\Event\ObserverInterface
{
    /**
     * @var QuoteRepository
     */
    private $_quote;

    /**
     * @var OrderRepository
     */
    private $_order;

    private $_logger;



    public function __construct(
        QuoteRepository $quoteFactory,
        OrderRepository $orderRepository,
        LoggerInterface $logger,

    )
    {
        $this->_quote = $quoteFactory;
        $this->_order = $orderRepository;
        $this->_logger = $logger;
    }

    /**
     * @inheritDoc
     */
    public function execute(Observer $observer)
    {
        /**
         * @var Order $order
         */
        $order = $observer->getOrder();
        $quoteId = $order->getQuoteId();
        $quote = $this->_quote->get($quoteId);
        $order->setRut($quote->getRut());
        $this->_order->save($order);
    }
}
