define([
    'Magento_Ui/js/lib/validation/validator',
    'jquery',
    'rut',
    'jquery/ui',
    'mage/validation',
    'mage/translate'
], function (validator, $, rut) {
    "use strict";

    $.widget('mage.rutValidation', {

        _create: function () {
            this._bind();
        },

        /**
         * Event binding, will monitor change, keyup and paste events.
         * @private
         */
        _bind: function () {
            this._on(this.element, {
                change: this.validateField,
                keyup: this.validateField,
                paste: this.validateField,
                focusout: this.validateField
            });
        },

        validateField: function () {
            let fax = $('input[name="fax"]:checked')
            if (fax.val() === "pasaporte") {
                return
            }

            this._addValidations();
            $.validator.validateSingleElement(this.element);
            this._formatRut(this.element)
        },

        /**
         *
         * @param element
         * @private
         */
        _formatRut: function (element) {
            if (element.val() !== "") {
                let value = rut.resetRut(element.val());
                element.val(rut.formatRut(value.replace(' ', ''), 2))
            }
        },

        _addValidations: function () {
            $.validator.addMethod(
                'required-rut',
                function (value) {
                    value = $.trim(value);
                    // 153926433
                    return rut.validateRutV1(value)
                },

                $.mage.__('Ingrese un RUT válido.')
            );

            validator.addRule(
                'required-rut',
                function (value, element) {
                    return $.validator.methods['validate-rut'].call(this, value, element);
                },
                $.mage.__('Ingrese un RUT válido.')
            );
        }
    });

    return $.mage.rutValidation;
});
