/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

define([
    'jquery',
    'mage/utils/wrapper',
    'Magento_CheckoutAgreements/js/model/agreements-assigner',
    'Magento_Checkout/js/model/quote',
], function ($, wrapper, agreementsAssigner, quote) {
    'use strict';

    return function (placeOrderAction) {

        /** Override default place order action and add agreement_ids to request */
        return wrapper.wrap(placeOrderAction, function (originalAction, paymentData, messageContainer) {

            let shippingAddress = quote.shippingAddress();
            let billingAddress = quote.billingAddress();
            if (billingAddress['extension_attributes'] === undefined) {
                billingAddress['extension_attributes'] = {};
            }

            if (shippingAddress['extension_attributes'] !== undefined) {
                billingAddress['extension_attributes'] = shippingAddress['extension_attributes'];
                billingAddress['extension_attributes'] = shippingAddress['extension_attributes'];
            }

            agreementsAssigner(paymentData);

            return originalAction(paymentData, messageContainer);
        });
    };
});