define([
    'jquery',
    'Magento_Ui/js/form/form',
    'ko'
], function ($, Component, ko) {
    'use strict';

    return Component.extend({
        defaults: {
            template: 'Ymina_Checkout/form/customer-register',
            logo: window.checkoutConfig.logoConfig,
            messageResponse: ko.observable(''),
            responseType: ko.observable('message success'),
            disabledSubmit: ko.observable(false)
        },

        initialize: function () {
            this._super();
            return this;
        },

        /**
         * Form submit handler
         *
         * This method can have any name.
         */
        onSubmit: function () {
            let self = this;
            this.source.set('params.invalid', false);
            this.source.trigger('customerRegister.data.validate');
            if (!this.source.get('params.invalid')) {
                let formData = this.source.get('customerRegister');
                console.log(formData)
                let url = BASE_URL + 'customer/popup/create';
                $.ajax({
                    url: url,
                    data: formData,
                    type: 'POST',
                    showLoader: true,
                    success: function (data) {
                        let msg = Array.isArray(data.message) ? data.message[0] : data.message;
                        if (data.success) {
                            self.responseType('message success');
                            self.messageResponse(msg)
                            self.disabledSubmit(true)
                            setInterval(function () {
                                window.location.reload();
                            }, 4000)

                        } else {
                            self.responseType('message error');
                            self.messageResponse(msg)
                        }
                    }
                });
            }
        },
    })
})