define([
    'underscore',
    'ko',
    'Magento_Customer/js/model/address-list',
    'Ymina_Checkout/js/helpers'
], function (_, ko, addressList, helpers) {
    let mixin = {

        limit: helpers.limitAddress,

        initialize: function () {
            this._super().initChildren();
            return this;
        },

        /** @inheritdoc */
        initChildren: function () {
            let self = this, _limit = self.limit();

            let address = addressList().filter(function (item, i, arr) {
                return i < helpers.limitAddress()
            })

            if (addressList().length < helpers.limitAddress()){
                address = addressList();
            }

            helpers.limitAddress.subscribe(function (value) {
                if (value > _limit) {
                    self.renderAddressNotInline(addressList())
                }
            })

            _.each(address, this.createRendererComponent, this);
            return this;
        },

        renderAddressNotInline: function (addressNotRenderer) {
            _.each(addressNotRenderer, this.createRendererComponent, this);
        }

    }

    return function (target) {
        return target.extend(mixin)
    }
})