define([
    'ko',
    'Magento_Checkout/js/model/quote',
    'Magento_Checkout/js/model/step-navigator',
], function (ko, quote, stepNavigator) {
    let mixin = {
        editAddress: ko.observable(true),

        initialize: function (){
            this._super()
            let self = this;
            quote.shippingMethod.subscribe(function (method) {
                if (method) {
                    self.editAddress(method.carrier_code !== "amstorepickup")
                }
            })
            return this
        },

        /**
         * @return {Boolean}
         */
        isVisible: function () {
            return !quote.isVirtual() && stepNavigator.isProcessed('shipping') !== false;
        },
    }

    return function (target) {
        return target.extend(mixin)
    }
})