<?php

namespace Ymina\CustomSearch\Controller\Attributes;

use Magento\Framework\App\Action\HttpGetActionInterface;
use Magento\Framework\App\RequestInterface;
use Magento\Framework\App\ResourceConnection;
use Magento\Framework\App\ResponseInterface;
use Magento\Framework\Controller\Result\Json;
use Magento\Framework\Controller\ResultInterface;
use Magento\Framework\Exception\NotFoundException;
use Ymina\CustomSearch\Model\CustomSearchIndex;

class Filter implements HttpGetActionInterface
{
    private Json $json;
    private RequestInterface $request;
    private CustomSearchIndex $customSearchIndex;

    public function __construct(Json $json, RequestInterface $request, CustomSearchIndex $customSearchIndex)
    {
        $this->json = $json;
        $this->request = $request;
        $this->customSearchIndex = $customSearchIndex;
    }

    /**
     * Execute action based on request and return result
     *
     * @return ResultInterface|ResponseInterface
     */
    public function execute(): ResultInterface|ResponseInterface
    {
        $params = $this->request->getParams(); // Obtiene los parámetros de la URL
        $result = $this->customSearchIndex->searchByParams($params);
        return $this->json->setData($result);
    }
}
