<?php

namespace Ymina\CustomSearch\Model\Config\Source;

use Magento\Eav\Model\AttributeRepository;
use Magento\Framework\Api\SearchCriteriaBuilder;
use Magento\Framework\Exception\InputException;

class ProductAttributes implements \Magento\Framework\Option\ArrayInterface
{
    const ATTRIBUTE_PRODUCT_TYPE = "catalog_product";
    private AttributeRepository $attributeRepository;
    private SearchCriteriaBuilder $searchCriteriaBuilder;

    public function __construct(AttributeRepository $attributeRepository, SearchCriteriaBuilder $searchCriteriaBuilder)
    {
        $this->attributeRepository = $attributeRepository;
        $this->searchCriteriaBuilder = $searchCriteriaBuilder;
    }

    /**
     * @throws InputException
     */
    public function toOptionArray(): array
    {
        $data = [];
        $criteria = $this->searchCriteriaBuilder->create();
        $attributes = $this->attributeRepository->getList(self::ATTRIBUTE_PRODUCT_TYPE, $criteria);
        foreach ($attributes->getItems() as $attribute) {
            $data[] = [
                "label" => $attribute->getFrontendLabel() ." (".$attribute->getAttributeCode().")",
                "value" => $attribute->getAttributeCode()
            ];
        }
        return $data;
    }
}


