<?php

namespace Ymina\CustomSearch\Model;

use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\Exception\LocalizedException;
use Magento\Store\Model\ScopeInterface;

class ConfigProvider
{
    const LLANTAS_PATH = "custom_search/general/llantas";
    const DISABLED_PATH = "custom_search/general/disabled";
    const PNEUMATICS_PATH = "custom_search/general/neumaticos";
    private ScopeConfigInterface $scopeConfig;

    public function __construct(ScopeConfigInterface $scopeConfig)
    {
        $this->scopeConfig = $scopeConfig;
    }

    public function getLLantas(): array
    {
        try {
            return explode(",", "aro,apernadura_configurable");
        } catch (LocalizedException $e) {
            return [];
        }
    }

    public function getPneumatics(): array
    {
        try {
            return explode(",", "tipo_de_vehiculo,ancho_neumatico,perfil_neumatico,aro");
        } catch (LocalizedException $e) {
            return [];
        }
    }

    public function isActiveModule()
    {
        return $this->scopeConfig->getValue(self::DISABLED_PATH);
    }
}
