<?php
/**
 * Copyright ©  All rights reserved.
 * See COPYING.txt for license details.
 */
declare(strict_types=1);

namespace Ymina\StoreLocator\Block\Widget;

use Amasty\Base\Model\Serializer;
use Amasty\Storelocator\Api\Validator\LocationProductValidatorInterface;
use Amasty\Storelocator\Helper\Data;
use Amasty\Storelocator\Model\BaseImageLocation;
use Amasty\Storelocator\Model\ConfigProvider;
use Amasty\Storelocator\Model\ImageProcessor;
use Amasty\Storelocator\Model\ResourceModel\Attribute\Collection as AttributeCollection;
use Amasty\Storelocator\Model\ResourceModel\Location\CollectionFactory;
use Magento\Catalog\Model\Product;
use Magento\Framework\Filesystem\Io\File;
use Magento\Framework\Json\EncoderInterface;
use Magento\Framework\Registry;
use Magento\Framework\View\Element\Template;
use Magento\Framework\View\Element\Template\Context;
use Magento\Widget\Block\BlockInterface;
use Amasty\Storelocator\Block\Location;

class StoreLocation extends Location implements BlockInterface
{
    protected $_template = "storelocation.phtml";

    public function __construct(Context $context, Registry $coreRegistry, EncoderInterface $jsonEncoder, File $ioFile, Data $dataHelper, AttributeCollection $attributeCollection, Serializer $serializer, ConfigProvider $configProvider, ImageProcessor $imageProcessor, Product $productModel, CollectionFactory $locationCollectionFactory, BaseImageLocation $baseImageLocation, LocationProductValidatorInterface $locationProductValidator, \Amasty\Storelocator\Api\ReviewRepositoryInterface $reviewRepository, array $data = [])
    {
        parent::__construct($context, $coreRegistry, $jsonEncoder, $ioFile, $dataHelper, $attributeCollection, $serializer, $configProvider, $imageProcessor, $productModel, $locationCollectionFactory, $baseImageLocation, $locationProductValidator, $reviewRepository, $data);
    }

}

