<?php

namespace Ymina\StructuredData\Block;

use Magento\Framework\View\Element\Template;
use Magento\Store\Model\ScopeInterface;

class IndexScript extends \Magento\Framework\View\Element\Template
{

    const PATCH_MODULE = 'ymina_structureddata/general/';


    /**
     * @var \Magento\Framework\Json\Helper\Data
     */
    protected $serialized;


    /**
     * @var \Magento\Framework\App\Config\ScopeConfigInterface
     */
    protected $scopeConfig;


    /**
     * @param Template\Context $context
     * @param \Magento\Framework\Json\Helper\Data $serialized
     * @param \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
     * @param array $data
     */
    public function __construct(
        Template\Context                                   $context,
        \Magento\Framework\Json\Helper\Data                $serialized,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        array                                              $data = [])
    {
        $this->serialized = $serialized;
        $this->scopeConfig = $scopeConfig;
        parent::__construct($context, $data);
    }

    /**
     * @return array
     */
    public function getDataToArray()
    {
        $structured_data = $this->scopeConfig->getValue(self::PATCH_MODULE . "structured_data", ScopeInterface::SCOPE_WEBSITE);
        return [
            "structured" => $structured_data,
            "removesc" => false,
            "jsonStringify" => false
        ];
    }

    /**
     * @return array
     */
    public function getDataadditionalToArray()
    {
        $structured_data = $this->scopeConfig->getValue(self::PATCH_MODULE . "structured_data_additional", ScopeInterface::SCOPE_WEBSITE);
        return [
            "structured" => $structured_data,
            "removesc" => false,
            "jsonStringify" => false
        ];
    }

    /**
     * @return string
     */
    public function serializedFormData($formData)
    {
        return $this->serialized->jsonEncode($formData);
    }
}
